]> git.pld-linux.org Git - packages/rpm.git/blobdiff - rpm.macros
- verbose (and faster) __spec_install_post_strip
[packages/rpm.git] / rpm.macros
index f84de902701f5f75d07f99671f60762fa8e2d19c..9df7ad3d7596130a7d7bdd6b179bcb4ba2e493ae 100644 (file)
@@ -1,5 +1,5 @@
 # $Revision$, $Date$
-# PLD rpm macros
+# PLD Linux rpm macros
 
 %epoch         0
 %x8664         x86_64 amd64 ia32e
@@ -8,9 +8,6 @@
 %kgcc          %{__cc}
 %kgcc_package  gcc
 
-%_source_payload       w9.gzdio
-%_binary_payload       w9.bzdio
-
 # Build system path macros.
 #
 %__autoconf            autoconf %{?debug:-Wall}
@@ -34,10 +31,14 @@ fi; \
 
 %__glib_gettextize     glib-gettextize --copy --force
 %__gnome_doc_common    gnome-doc-common --copy
+%__gnome_doc_prepare   gnome-doc-prepare --copy --force
 %__gtkdocize           gtkdocize --copy
 %__intltoolize         intltoolize --copy --force
 %__libtoolize          libtoolize --copy --force
 
+#      The number of cvs changelog entries kept when building package.
+%_buildchangelogtruncate 20
+
 %dependencytracking    %{nil}
 
 #      Relations between package names that cause dependency loops
@@ -50,6 +51,60 @@ fi; \
 #      and that both p and q are package names (i.e. no version/release).
 %_dependency_whiteout  %{nil}
 
+
+#-----------------------------------------------------------------
+#
+# (re)definition of %{rpm*flags} with %filterout_* support
+# Requires:            awk
+#
+# Flags specified in %filterout_* are removed from %rpm*flags, exactly:
+# %rpmcflags    = %optflags - %filterout - %filterout_c   - %filterout_ld
+# %rpmcxxflags  = %optflags - %filterout - %filterout_cxx - %filterout_ld
+# %rpmldflags   = %optldflags - %filterout_ld
+#
+# Regular expressions are supported, but to avoid some character be treated
+# as regular expression it must be escaped twice.
+
+%filter_out                                            \
+       for (i in I) {  A=0;                    \
+               for (f in F) {                          \
+                       if (I[i] ~ "^" F[f] "$") A=1;   \
+               };                                                      \
+               if (!A) printf(I[i] FS);        \
+       }
+
+%rpmcflags %(awk 'BEGIN {
+       split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
+       split("%{?filterout} %{?filterout_c} %{?filterout_ld}",F);
+       %{filter_out}
+}')
+
+%rpmcxxflags %(awk 'BEGIN {
+       split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
+       split("%{?filterout} %{?filterout_cxx} %{?filterout_ld}",F);
+       %{filter_out}
+}')
+
+%rpmldflags %(awk 'BEGIN {
+       split("%{?optldflags}",I);
+       split("%{?filterout_ld}",F)
+       %{filter_out}
+}')
+
+# rpmldflags with stripped -Wl, -- in the form flags have to be passed to 'ld'
+# but, don't use it, better use gcc as linker
+%ld_rpmldflags %(awk 'BEGIN {
+        split("%{rpmldflags}",F);
+        for (f in F) {
+                s = F[f];
+                if (s ~ /^-Wl,/) {
+                        s = substr(s,5);
+                        gsub(/,/," ",s);
+                };
+                printf(s FS);
+        };
+}')
+
 #-----------------------------------------------------------------
 %configure2_13 { \
  if [ -n "$LINGUAS" ]; then unset LINGUAS; fi; \
@@ -75,13 +130,41 @@ fi; \
        --sharedstatedir=%{_sharedstatedir} \
        --mandir=%{_mandir} \
        --infodir=%{_infodir} \
-       --x-libraries=/usr/X11R6/%{_lib} \
+       --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
        %{dependencytracking} \
 }
 
+# override __cmake to add -j4 in your ~/.rpmmacros for parallel make
+%__cmake       /usr/bin/cmake
+%cmake { \
+CC="%{__cc}" \
+CXX="%{__cxx}" \
+CFLAGS="%{rpmcflags}" \
+CXXFLAGS="%{rpmcxxflags}" \
+%{__cmake} \
+}
+
+# override __scons to add -j4 in your ~/.rpmmacros for parallel make
+%__scons       /usr/bin/scons
+%scons { \
+%{__scons} \
+}
+
+# waf. see waf.spec
+# override __waf to add -j4 in your ~/.rpmmacros for parallel make
+%__waf /usr/bin/waf
+%waf { \
+CC="%{__cc}" \
+CXX="%{__cxx}" \
+CPP="%{__cpp}" \
+CFLAGS="%{rpmcflags}" \
+CXXFLAGS="%{rpmcxxflags}" \
+%{__waf} \
+}
+
 #----------------------------------------------------------------
 %global configure_cache 0
-%configure_cache_file   %{buildroot}.configure.cache
+%configure_cache_file  %{buildroot}.configure.cache
 
 %configure {./configure \
        LDFLAGS="${LDFLAGS:-%rpmldflags}" \
@@ -106,7 +189,7 @@ fi; \
        --sharedstatedir=%{_sharedstatedir} \
        --mandir=%{_mandir} \
        --infodir=%{_infodir} \
-       --x-libraries=/usr/X11R6/%{_lib} \
+       --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
        %{dependencytracking} \
        %{?configure_cache:--cache-file=%{configure_cache_file:-%{buildroot}.configure.cache}} \
 }
@@ -115,17 +198,21 @@ fi; \
 # Overloading of some basic macros
 %prep \
 %%prep\
-LANG=C\
-export LANG\
-unset DISPLAY ||:\
+export LC_ALL=C\
+export LANG=C\
 unset LINGUAS ||:\
+unset LANGUAGE ||:\
+unset LC_MESSAGES ||:\
+unset DISPLAY ||:\
 %{nil}
 
 %build %%build\
-LANG=C\
-export LANG\
-unset DISPLAY ||:\
+export LC_ALL=C\
+export LANG=C\
 unset LINGUAS ||:\
+unset LANGUAGE ||:\
+unset LC_MESSAGES ||:\
+unset DISPLAY ||:\
 %{nil}
 
 %install \
@@ -133,10 +220,12 @@ unset LINGUAS ||:\
 %{?buildsubdir:%{debug_package}}\
 %endif\
 %%install\
-LANG=C\
-export LANG\
-unset DISPLAY ||:\
+export LC_ALL=C\
+export LANG=C\
 unset LINGUAS ||:\
+unset LANGUAGE ||:\
+unset LC_MESSAGES ||:\
+unset DISPLAY ||:\
 %{nil}
 
 # Location of autoconf macros
@@ -162,10 +251,10 @@ unset LINGUAS ||:\
 %_fontsdir     /usr/share/fonts
 
 # Location of Gtk and associated libraries documentation
-%_gtkdocdir  %{_defaultdocdir}/gtk-doc/html
+%_gtkdocdir    %{_defaultdocdir}/gtk-doc/html
 
 # Location of KDE documentation
-%_kdedocdir  %{_defaultdocdir}/kde/HTML
+%_kdedocdir    %{_defaultdocdir}/kde/HTML
 
 # unsermake script
 %__unsermake /usr/share/unsermake/unsermake
@@ -179,8 +268,11 @@ unset LINGUAS ||:\
 # Example files, programs, scripts...
 %_examplesdir  /usr/src/examples
 
+# Alternative kernel type/version
+%_alt_kernel   %{nil}%{?alt_kernel:-%{?alt_kernel}}
+
 # The directory holding Linux kernel sources
-%_kernelsrcdir /usr/src/linux
+%_kernelsrcdir /usr/src/linux%{_alt_kernel}
 
 # If non-empty "debug" macro defined, add "dbg" suffix to release number
 %_rpmfilename          %%{NAME}-%%{VERSION}-%%{RELEASE}%{?debug:dbg}.%%{ARCH}.rpm
@@ -188,19 +280,20 @@ unset LINGUAS ||:\
 # Requires name = version-release
 %requires_releq()              %(echo '%*' | LC_ALL="C" xargs -r rpm -q --qf 'Requires: %%{name} = %%{epoch}:%%{version}-%%{release}\\n' | sed -e 's/ (none):/ /' | grep -v "is not")
 
-%releq_kernel_up()             %(LC_ALL="C" rpm -qf --qf '%%{name}-up = %%{epoch}:%%{version}-%%{release}\\n' %{_kernelsrcdir}/include/linux/version.h | sed -e 's/ (none):/ /' | sed -e 's:-headers::' | grep -vE "(is not|no such)")
-%releq_kernel_smp()            %(LC_ALL="C" rpm -qf --qf '%%{name}-smp = %%{epoch}:%%{version}-%%{release}\\n' %{_kernelsrcdir}/include/linux/version.h | sed -e 's/ (none):/ /' | sed -e 's:-headers::' | grep -vE "(is not|no such)")
-%requires_releq_kernel_up()    %(LC_ALL="C" rpm -qf --qf 'PreReq: %%{name}-up = %%{epoch}:%%{version}-%%{release}\\n' %{_kernelsrcdir}/include/linux/version.h | sed -e 's/ (none):/ /' | sed -e 's:-headers::' | grep -vE "(is not|no such)")
-%requires_releq_kernel_smp()   %(LC_ALL="C" rpm -qf --qf 'PreReq: %%{name}-smp = %%{epoch}:%%{version}-%%{release}\\n' %{_kernelsrcdir}/include/linux/version.h | sed -e 's/ (none):/ /' | sed -e 's:-headers::' | grep -vE "(is not|no such)")
+%releq_kernel_up()             %((LC_ALL="C" rpm -qf --qf '%%{name}-up = %%{epoch}:%%{version}-%%{release}\\n' %{_kernelsrcdir}/include/linux/version.h 2>/dev/null || echo ERROR) | sed -e 's/ (none):/ /' | sed -e 's:-headers::' | grep -vE "(is not|no such)")
+%releq_kernel_smp()            %((LC_ALL="C" rpm -qf --qf '%%{name}-smp = %%{epoch}:%%{version}-%%{release}\\n' %{_kernelsrcdir}/include/linux/version.h 2>/dev/null || echo ERROR) | sed -e 's/ (none):/ /' | sed -e 's:-headers::' | grep -vE "(is not|no such)")
+%requires_releq_kernel_up(s:)  Requires%{-s:(%{-s*})}: %releq_kernel_up
+%requires_releq_kernel_smp(s:) Requires%{-s:(%{-s*})}: %releq_kernel_smp
 
+%requires_eq()         %(echo '%*' | LC_ALL="C" xargs -r rpm -q --qf 'Requires: %%{name} = %%{epoch}:%%{version}\\n' | sed -e 's/ (none):/ /' -e 's/ 0:/ /' | grep -v "is not")
 %requires_eq_to() %(LC_ALL="C" rpm -q --qf 'Requires: %1 = %%{epoch}:%%{version}\\n' %2 | sed -e 's/ (none):/ /' | grep -v "is not")
 
 %apache_modules_api %(awk '/#define MODULE_MAGIC_NUMBER_MAJOR/ {print $3}' /usr/include/apache/ap_mmn.h 2>/dev/null || echo ERROR)
 
 # kernel version-release handling
-%__kernel_ver  %([ -f %{_kernelsrcdir}/include/linux/version.h ] && (grep UTS_RELEASE %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | head -n 1 | cut -d'"' -f2) || (awk '/^VERSION/ { ver = $0; gsub(/VERSION.*=/, NIL, ver); } /^PATCHLEVEL/ { plev = $0; gsub(/PATCHLEVEL.*=/, NIL, plev); } /^SUBLEVEL/ { slev = $0; gsub(/SUBLEVEL.*=/, NIL, slev); } /^EXTRAVERSION/ { ever = $0; gsub(/EXTRAVERSION.*=/, NIL, ever); gsub(/ /, NIL, ever); } END { printf("%d.%d.%d%s", ver, plev, slev, ever); }' %{_kernelsrcdir}/Makefile 2> /dev/null))
+%__kernel_ver  %( VER_H=%{_kernelsrcdir}/include/linux/utsrelease.h; [ -f $VER_H ] || VER_H=%{_kernelsrcdir}/include/linux/version.h; [ -f $VER_H ] && (grep UTS_RELEASE $VER_H 2>/dev/null | head -n 1 | cut -d'"' -f2) || (awk '/^VERSION/ { ver = $0; gsub(/VERSION.*=/, NIL, ver); } /^PATCHLEVEL/ { plev = $0; gsub(/PATCHLEVEL.*=/, NIL, plev); } /^SUBLEVEL/ { slev = $0; gsub(/SUBLEVEL.*=/, NIL, slev); } /^EXTRAVERSION/ { ever = $0; gsub(/EXTRAVERSION.*=/, NIL, ever); gsub(/ /, NIL, ever); } END { printf("%d.%d.%d%s", ver, plev, slev, ever); }' %{_kernelsrcdir}/Makefile 2> /dev/null))
 %__kernel_rel  %(LC_ALL="C" rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{RELEASE}" | grep -v "is not")
-%__kernel_rpmvr  %(LC_ALL="C" rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{VERSION}-%{RELEASE}" | grep -v "is not")
+%__kernel_rpmvr        %(LC_ALL="C" rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{VERSION}-%{RELEASE}" | grep -v "is not")
 %_kernel_ver   %{__kernel_ver}%{?with_dist_kernel:%(echo %{__kernel_ver} | grep -q -e - || echo -%{__kernel_rel})}
 %_kernel_ver_str %(echo %{!?_without_dist_kernel:%{__kernel_rpmvr}}%{?_without_dist_kernel:%{__kernel_ver}} | sed -e 's/-/_/g')
 
@@ -222,6 +315,14 @@ unset LINGUAS ||:\
 ; do echo $l; done >> %1 \
 }
 
+# minimum file size needed for compressed documents.
+# just smaller files than this get larger when compressed.
+# some stats:
+# - 0 byte file compressed was 25 bytes .gz
+# - 39 byte file was compressed as 57
+# - with test/test.spec@man 158 byte file was compressed also 158
+%_min_compress_bytes   159
+
 #-----------------------------------------------------------------
 # find and gzip all files in %{_mandir} and %{infodir}
 #
@@ -229,17 +330,16 @@ unset LINGUAS ||:\
 #
 #%no_install_post_compress_docs        1
 %__spec_install_post_compress_docs { \
-%{!?no_install_post_compress_docs: \
+%{!?no_install_post_compress_docs:__spec_install_post_compress_docs() { \
        echo "Compress man and info pages."; \
-       %{?verbose:set -x;} \
        for i in /usr/share/man /usr/X11R6/man /usr/share/info; do \
                if [ -d "$RPM_BUILD_ROOT$i" ]; then \
-                       find "$RPM_BUILD_ROOT$i" -name \*.bz2 -print | xargs -r %{__bzip2} -df; \
-                       find "$RPM_BUILD_ROOT$i" -name \*.gz -print | xargs -r %{__gzip} -dnf; \
-                       find "$RPM_BUILD_ROOT$i" -type f -print | xargs -r %{__gzip} -9nf; \
+                       find "$RPM_BUILD_ROOT$i" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
+                       find "$RPM_BUILD_ROOT$i" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
+                       find "$RPM_BUILD_ROOT$i" -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
                fi; \
        done; \
-} }
+}; __spec_install_post_compress_docs } }
 
 #-----------------------------------------------------------------
 # Strip executable binaries and shared object files
@@ -248,28 +348,34 @@ unset LINGUAS ||:\
 #
 #%no_install_post_strip        1
 %__spec_install_post_strip {%{!?debug: \
-%{!?no_install_post_strip: \
-%{?verbose:set -x;} \
+%{!?no_install_post_strip:__spec_install_post_strip() { \
        if [ -d "$RPM_BUILD_ROOT" ]; then \
        echo "Strip executable binaries, archives and shared object files."; \
        filelist=`find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*\.debug" %{?_noautostrip:! -regex "%{_noautostrip}"}`; \
-       elfexelist=`echo $filelist | xargs -r file | \
-               awk '/ELF.*executable/ {print $1}' | cut -d: -f1`; \
-       elfsharedlist=`echo $filelist | xargs -r file | \
-               awk '/LF.*shared object/ {print $1}' | cut -d: -f1`; \
-       elfarchiveslist=`echo $filelist | xargs -r file | \
-               awk '/current ar archive/ {print $1}' | cut -d: -f1`; \
+       printf "Considering %d files\n" $(echo "$filelist" | wc -l); \
+       filetypes=`echo $filelist | xargs -r file` \
+       elfexelist=`echo "$filetypes" | awk '/ELF.*executable/ {print $1}' | cut -d: -f1`; \
+       elfsharedlist=`echo "$filetypes" | awk '/LF.*shared object/ {print $1}' | cut -d: -f1`; \
+       archiveslist=`echo "$filetypes" | awk '/current ar archive/ {print $1}' | cut -d: -f1`; \
        if [ -n "$elfexelist" ]; then \
-               %{__strip} --remove-section=.note  --remove-section=.comment $elfexelist; \
+               printf "Stripping %d ELF executables..." $(echo "$elfexelist" | wc -l); \
+               chmod u+w $elfexelist; \
+               %{__strip} --remove-section=.note --remove-section=.comment $elfexelist; \
+               echo "DONE"; \
        fi; \
        if [ -n "$elfsharedlist" ]; then \
-               %{__strip} --strip-unneeded --remove-section=.note  --remove-section=.comment $elfsharedlist; \
+               printf "Stripping %d ELF shared libraries..." $(echo "$elfsharedlist" | wc -l); \
+               chmod u+w $elfsharedlist; \
+               %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $elfsharedlist; \
+               echo "DONE"; \
        fi; \
-       if [ -n "$elfarchiveslist" ]; then \
-               %{__strip} --strip-debug --remove-section=.note  --remove-section=.comment $elfarchiveslist; \
+       if [ -n "$archiveslist" ]; then \
+               printf "Stripping %d ar archives..." $(echo "$elfsharedlist" | wc -l); \
+               chmod u+w $archiveslist; \
+               %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $archiveslist; \
+               echo "DONE"; \
        fi; \
-fi; } \
-} }
+fi; }; __spec_install_post_strip } } }
 
 #-----------------------------------------------------------------
 # remove all RPATH from executable binaries and shared object files
@@ -278,8 +384,7 @@ fi; } \
 #
 #%no_install_post_chrpath      1
 %__spec_install_post_chrpath {%{!?debug: \
-%{!?no_install_post_chrpath: \
-       %{?verbose:set -x;} \
+%{!?no_install_post_chrpath: __spec_install_post_chrpath() { \
 if [ -d "$RPM_BUILD_ROOT" ]; then \
 echo "Remove RPATH from executable binaries and shared object files."; \
 find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*" %{?_noautochrpath:! -regex "%{_noautochrpath}"} | xargs -r file | \
@@ -302,27 +407,30 @@ while read file ; do \
        if [ "$rpath" = "" ] ; then chrpath -d "$file" > /dev/null ; \
        else chrpath -r "$rpath" "$file" > /dev/null ; fi ; \
 done; \
-fi; } \
-} }
+fi; }; __spec_install_post_chrpath } } }
 
 #-----------------------------------------------------------------
 # Find and gzip all kernel modules
 #
 # Requires: find
 #
-#%no_install_post_compress_modules  1
+#%no_install_post_compress_modules     1
 %__spec_install_post_compress_modules { \
-%{!?no_install_post_compress_modules: \
-       %{?verbose:set -x;} \
-       if [ -d "$RPM_BUILD_ROOT" ]; then \
-               echo "Compress kernel modules if any."; \
-               if test -d $RPM_BUILD_ROOT/lib/modules ; then \
-                       find $RPM_BUILD_ROOT/lib/modules -name \*o -type f -print | \
-                       xargs -r %{__gzip} -9nf; \
-                          find $RPM_BUILD_ROOT/lib/modules -name \*o -type l -printf "%p %l\n" | \
-                          while read a b; do ln -sf $b.gz $a.gz; rm -f $a; done; \
-               fi; \
+%{!?no_install_post_compress_modules: __spec_install_post_compress_modules() { \
+       if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
+               echo "Compress kernel modules"; \
+               q=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
+               echo "$q" | xargs -r %{__gzip} -9nf; \
+               printf "%d modules compressed\n" $(echo "$q" | wc -l); \
+               find $RPM_BUILD_ROOT/lib/modules -name '*o' -type l -printf "%p %l\n" | \
+               while read a b; do ln -sf $b.gz $a.gz; rm -f $a; done; \
        fi; \
+}; __spec_install_post_compress_modules } }
+
+# Remove common Perl files we don't package
+%__spec_install_post_perl_clean {\
+%{!?no_install_post_perl_clean: \
+%{?pdir:rm -f $RPM_BUILD_ROOT{%{perl_archlib}/perllocal.pod,%{perl_vendorarch}/auto/%{pdir}%{?pnam:/%(echo %{pnam} | tr - /)}/.packlist}} \
 } }
 
 #-----------------------------------------------------------------
@@ -348,16 +456,34 @@ fi \
 #
 %update_desktop_database_post() {{ \
        umask 022; \
-       /usr/bin/update-desktop-database; \
+       /usr/bin/update-desktop-database -q; \
 }}
 
 %update_desktop_database_postun() {{ \
 if [ $1 = 0 ]; then \
        umask 022; \
-       /usr/bin/update-desktop-database; \
+       /usr/bin/update-desktop-database -q; \
 fi \
 }}
 
+#-----------------------------------------------------------------
+# Update shared MIME info database
+# requires: shared-mime-info
+#
+%update_mime_database() {{ \
+       umask 022; \
+       /usr/bin/update-mime-database %{_datadir}/mime; \
+}}
+
+#-----------------------------------------------------------------
+# Update icon cache
+# requires: gtk+
+#
+%update_icon_cache() {{ \
+       umask 022; \
+       /usr/bin/gtk-update-icon-cache -qf %{_datadir}/icons/%1; \
+}}
+
 #-----------------------------------------------------------------
 # Update scrollkeeper database
 # requires: scrollkeeper
@@ -372,17 +498,6 @@ if [ $1 = 0 ]; then \
 fi \
 %{nil}
 
-#-----------------------------------------------------------------
-# Run ldconfig after installing/deinstalling libraries
-#
-%ldconfig_post() \
-       /sbin/ldconfig; \
-       %{nil}
-
-%ldconfig_postun() \
-       /sbin/ldconfig; \
-       %{nil}
-
 #-----------------------------------------------------------------
 # post %install sequence:
 # - autodeps exceptions
@@ -424,20 +539,25 @@ fi \
 %perl_sitearch         %(eval "`%{__perl} -V:installsitearch`"; echo $installsitearch)
 
 # Ruby
-%ruby_archdir          %(ruby -r rbconfig -e 'print Config::CONFIG["archdir"]')
-%ruby_ridir            %(ruby -r rbconfig -e 'include Config; print File.join(CONFIG["datadir"], "ri", CONFIG["ruby_version"], "system")')
-%ruby_rubylibdir       %(ruby -r rbconfig -e 'print Config::CONFIG["rubylibdir"]')
-%ruby_sitearchdir      %(ruby -r rbconfig -e 'print Config::CONFIG["sitearchdir"]')
-%ruby_sitelibdir       %(ruby -r rbconfig -e 'print Config::CONFIG["sitelibdir"]')
-%ruby_version          %(ruby -r rbconfig -e 'print Config::CONFIG["ruby_version"]')
-
-%php_pear_dir  %{_datadir}/pear
+%ruby_archdir          %(ruby -r rbconfig -e 'print Config::CONFIG["archdir"]' 2>/dev/null || echo ERROR)
+%ruby_ridir                    %(ruby -r rbconfig -e 'include Config; print File.join(CONFIG["datadir"], "ri", CONFIG["ruby_version"], "system")' 2>/dev/null || echo ERROR)
+%ruby_rubylibdir       %(ruby -r rbconfig -e 'print Config::CONFIG["rubylibdir"]' 2>/dev/null || echo ERROR)
+%ruby_sitearchdir      %(ruby -r rbconfig -e 'print Config::CONFIG["sitearchdir"]' 2>/dev/null || echo ERROR)
+%ruby_sitelibdir       %(ruby -r rbconfig -e 'print Config::CONFIG["sitelibdir"]' 2>/dev/null || echo ERROR)
+%ruby_version          %(ruby -r rbconfig -e 'print Config::CONFIG["ruby_version"]' 2>/dev/null || echo ERROR)
+%ruby_ver_requires_eq  Requires:       ruby(ver) = %ruby_version
+%ruby_mod_ver_requires_eq      Requires:       ruby-modules(ver) = %ruby_version
+
+%php_pear_dir          /usr/share/pear
+%php_extensiondir      %(php-config --extension-dir 2>/dev/null || echo ERROR)
+%php_sysconfdir                %(php-config --sysconfdir 2>/dev/null || echo ERROR)
 
 # directory where php includes are installed on system.
 %__php_includedir              /usr/include/php
 # extract php/zend api versions
 %php_major_version             %(awk '/#define PHP_MAJOR_VERSION/{print $3}' %{__php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)
 %php_api_version               %(awk '/#define PHP_API_VERSION/{print $3}' %{__php_includedir}/main/php.h 2>/dev/null || echo ERROR)
+%php_pdo_api_version   %(awk '/#define PDO_DRIVER_API/{print $3}' %{__php_includedir}/ext/pdo/php_pdo_driver.h 2>/dev/null || echo ERROR)
 %php_debug                             %(awk '/#define ZEND_DEBUG/{print $3}' %{__php_includedir}/main/php_config.h 2>/dev/null || echo ERROR)
 %zend_module_api               %(awk '/#define ZEND_MODULE_API_NO/{print $3}' %{__php_includedir}/Zend/zend_modules.h 2>/dev/null || echo ERROR)
 %zend_extension_api            %(awk '/#define ZEND_EXTENSION_API_NO/{print $3}' %{__php_includedir}/Zend/zend_extensions.h 2>/dev/null || echo ERROR)
@@ -449,6 +569,7 @@ fi \
 # macros for public use
 # for php extensions (php-pecl)
 %requires_php_extension %{__php_api_requires modules_api php_api_version} \
+%{__php_api_requires zend_module_api} \
 %{__php_api_requires -v %php_major_version debug php_debug} \
 %{__php_api_requires -v %php_major_version thread-safety zend_zts}
 
@@ -458,16 +579,43 @@ fi \
 %{__php_api_requires -v %php_major_version debug php_debug} \
 %{__php_api_requires -v %php_major_version thread-safety zend_zts}
 
+# for php pdo modules (php-pecl-PDO_*)
+%requires_php_pdo_module %{__php_api_requires PDO_API php_pdo_api_version}
+
+# for using PHP post scripts. for PHP >= 5.0
+%php_webserver_restart \
+[ ! -f /etc/apache/conf.d/??_mod_php.conf ] || %service -q apache restart \
+[ ! -f /etc/httpd/conf.d/??_mod_php.conf ] || %service -q httpd restart \
+if [ -f /etc/rc.d/init.d/php-fcgi ]; then \
+       PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
+       if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php.fcgi* ]]; then \
+               %service -q php-fcgi restart \
+       fi \
+fi \
+%{nil}
+
+# for using php post scripts. for PHP >= 4.0 && PHP < 5.0
+%php4_webserver_restart \
+[ ! -f /etc/apache/conf.d/??_mod_php4.conf ] || %service -q apache restart \
+[ ! -f /etc/httpd/conf.d/??_mod_php4.conf ] || %service -q httpd restart \
+if [ -f /etc/rc.d/init.d/php-fcgi ]; then \
+       PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
+       if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php4.fcgi* ]]; then \
+               %service -q php-fcgi restart \
+       fi \
+fi \
+%{nil}
+
 # Python specific macro definitions.
 # python main version
-%py_ver                %(python -c "import sys; print sys.version[:3]")
+%py_ver                        %(python -c "import sys; print sys.version[:3]")
 
 # directories
 %py_prefix             %(python -c "import sys; print sys.prefix")
 %py_libdir             %{py_prefix}/%{_lib}/python%{py_ver}
 %py_scriptdir  %{py_prefix}/share/python%{py_ver}
 %py_incdir             /usr/include/python%{py_ver}
-%py_sitedir    %{py_libdir}/site-packages
+%py_sitedir            %{py_libdir}/site-packages
 %py_sitescriptdir %{py_scriptdir}/site-packages
 %py_dyndir             %{py_libdir}/lib-dynload
 
@@ -482,14 +630,14 @@ fi \
 # Hardlink binary identical .pyc and .pyo files
 # (idea by glen <at> pld-linux <dot> org)
 %__spec_install_post_py_hardlink {\
-%{!?no_install_post_py_hardlink: \
+%{!?no_install_post_py_hardlink: __spec_install_post_py_hardlink() { \
 [ ! -d "$RPM_BUILD_ROOT" ] || find "$RPM_BUILD_ROOT" -name '*.pyc' | while read a; do \
        b="$(echo $a|sed -e 's/.pyc$/.pyo/')"; \
        if cmp -s "$a" "$b"; then \
                ln -f "$a" "$b"; \
        fi; \
 done \
-} }
+}; __spec_install_post_py_hardlink } }
 
 # remove python sources, so that check-files won't complain
 # (idea by glen <at> pld-linux <dot> org)
@@ -577,8 +725,8 @@ fi \
 eval $CMD %2%{?3: %3} \
 %nil
 
-# useradd/groupadd macros written by glen@pld-linux.org.
-# All rights reserved. Permission to copy is hereby granted.. yada, yada, yada
+# useradd/groupadd macros
+# Author: Elan Ruusamäe <glen@pld-linux.org>
 #
 # Usage:
 #   %useradd [-P package] [-u uid] [-d home_dir] [-s shell] [-c comment]
@@ -615,7 +763,8 @@ else \
                -g %{-g*} \\\
                %{-M} \\\
                %{-G:-G %{-G*}} \\\
-               %{expand:%{%{#}}} 1>&2 \
+               %{expand:%{%{#}}} 1>&2 || exit $? \
+       [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i passwd || : \
 fi;
 
 # Usage:
@@ -636,11 +785,15 @@ if [ -n "`/usr/bin/getgid %{1}`" ]; then \
        fi \
 else \
        echo "Adding group %{1} GID=%{-g*}." \
-       /usr/sbin/groupadd -g %{-g*} -r %{1} 1>&2 \
+       /usr/sbin/groupadd -g %{-g*} -r %{1} 1>&2 || exit $? \
+       [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i group || : \
 fi;
 
-# apache_config_{install/uninstall} macros written by glen@pld-linux.org.
-# All rights reserved. Permission to copy is hereby granted.. yada, yada, yada
+# apache_config_{install/uninstall} macros *DEPRECATED*
+# Author: Elan Ruusamäe <glen@pld-linux.org>
+#
+# You should use webapp macros instead. these are here until single piece of
+# them is gone from specs ;)
 #
 # The config is installed/removed inside trigger, this means that you can any
 # time install apache1 or apache package and the configuration file is updated.
@@ -661,6 +814,7 @@ fi;
 #  -v REQUIRED: specify apache version. can be 1 or 2.
 #  -c OPTIONAL: specify full path to PACKAGE's config. Defaults to %{_sysconfdir}/apache-%{name}.conf.
 #  -n OPTIONAL: specify config "slot". defaults to 99
+#  -f OPTIONAL: force symlink creation regardless if package was upraded. useful in triggers
 #
 # Internal macros. don't use ;).
 # expands apache config dir by apache version at build time.
@@ -668,10 +822,10 @@ fi;
 # expands apache service name by apache version at build time.
 %__apache_svcname() %(if [ %{1} = 1 ]; then echo apache; elif [ %{1} = 2 ]; then echo httpd; else echo >&2 Unknown apache version specified; fi)
 
-%apache_config_install(v:c:n:) \
+%apache_config_install(fv:c:n:) \
 %{!-v:%{error:apache_config_install: Required argument -v missing}} \
 %{?debug:set -x; echo "apache_config_install:%{-v*} %{name}-%{version}-%{release} 1:[$1]; 2:[$2]"} \
-if [ "$1" = "1" ] && [ "$2" = "1" ] && [ -d %{__apache_confdir %{-v*}} ]; then\
+if [ -n "%{-f:1}" ] || ([ "$1" = "1" ] && [ "$2" = "1" ]) && [ -d %{__apache_confdir %{-v*}} ]; then\
        ln -sf %{-c*}%{!-c:%{_sysconfdir}/apache-%{name}.conf} %{__apache_confdir %{-v*}}/%{-n*}%{!-n:99}_%{name}.conf\
 fi\
 # reload apache if the config symlink is there\
@@ -705,10 +859,11 @@ fi \
 %{nil}
 
 # webapp macros
+# Author: Elan Ruusamäe <glen@pld-linux.org>
 #
 # The config is installed/removed inside trigger, this means that you can any
 # time install apache1/apache/lighttpd package and the configuration file is
-# updated.  if you don't need the config for various reason for specific
+# updated. if you don't need the config for various reason for specific
 # webserver, just remove the symlink from config directory using webapp
 # program. the trigger will not recreate the symlink on upgrades. In other
 # words the config is linked to webserver config directory on first install of
@@ -724,27 +879,25 @@ if [ "$1" = "1" ] && [ "$2" = "1" ]; then\
        /usr/sbin/webapp register %1 %2\
 fi\
 # reload webserver if the config symlink is there and skip reload if webserver is upgraded\
-if [ -L /etc/%1/webapps.d/%2.conf ] && [ "$2" -lt "2" ] && [ -f /var/lock/subsys/%1 ]; then\
-       /etc/rc.d/init.d/%1 reload 1>&2\
+if [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ] && [ "$2" -lt "2" ]; then\
+       %{expand:%service -q %%1 reload}\
 fi\
 %{nil}
 
 # Remove package's config from webserver webapps dir.
 # Usage:
-#   %webapp_register WEBSERVER WEBAPP
-%webapp_unregister() \
+#   %webapp_register [-f] WEBSERVER WEBAPP
+%webapp_unregister(f) \
 %{?debug:set -x; echo "webapp_unregister: %{name}-%{version}-%{release}: 1:[$1]; 2:[$2]"} \
 # remove link if either of the packages are gone \
-if [ "$1" = "0" ] || [ "$2" = "0" ] && [ -L /etc/%1/webapps.d/%2.conf ]; then \
+if [ -n "%{-f:1}" ] || [ "$1" = "0" ] || [ "$2" = "0" ] && [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ]; then \
        /usr/sbin/webapp unregister %1 %2\
-       if [ -f /var/lock/subsys/%1 ]; then \
-               /etc/rc.d/init.d/%1 reload 1>&2 \
-       fi \
+       %{expand:%service -q %%1 reload}\
 fi \
 %{nil}
 
 # see browser-plugins.spec / template-browser-plugin.spec
-# written by glen@pld-linux.org.
+# Author: Elan Ruusamäe <glen@pld-linux.org>
 %nsplugin_install(d:f) { \
 # create link if it's first install of either of the packages \
 if [ -n "%{-f:1}" ] || ([ "$1" = "1" ] && [ "$2" = "1" ] && [ -d %{-d*} ]); then \
@@ -770,17 +923,346 @@ if [ "$1" = "0" ] || [ "$2" = "0" ]; then \
 }
 
 # service macro.
+# Author: Elan Ruusamäe <glen@pld-linux.org>
 #
 # calls usual service restart on package %post, but skips the restart if
 # administrator has disabled automatic service restarts in either global
 # /etc/sysconfig/rpm or per service /etc/sysconfig/SERVICE file.
 #
-# written by glen@pld-linux.org.
-# All rights reserved. Permission to copy is hereby granted.. yada, yada, yada
-#
 # Usage:
 #   %service [-q] SERVICE ACTION ["SERVICE NICE DESCRIPTION"]
 #
-#  -q be silent when service isn't started (for postun scriplets)
+#  -q be silent when service isn't started (for scriplets restaring other package's services)
 #
 %service(q) {{%(export quiet=%{-q:1}; /usr/lib/rpm/service_generator.sh %{*}) };}
+
+
+# java macros. based on jpackage macros.java
+%_jvmdir               %{_libdir}/jvm
+%_jvmjardir            %{_libdir}/jvm-exports
+%_jvmprivdir           %{_libdir}/jvm-private
+%_jvmlibdir            %{_libdir}/jvm
+%_jvmdatadir           %{_datadir}/jvm
+%_jvmsysconfdir                %{_sysconfdir}/jvm
+# FIXME: are these used?
+%_jvmcommonlibdir      %{_libdir}/jvm-common
+%_jvmcommondatadir     %{_datadir}/jvm-common
+%_jvmcommonsysconfdir  %{_sysconfdir}/jvm-common
+%_jnidir               %{_libdir}/java
+%java_home             %(unset JAVA_HOME; . %{_javadir}-utils/java-functions; set_jvm; echo $JAVA_HOME)
+
+%ant                   JAVA_HOME=%{java_home} ant
+%jar                   %{java_home}/bin/jar
+%java                  %(unset JAVACMD; . %{_javadir}-utils/java-functions; set_javacmd; echo $JAVACMD)
+%javac                 %{java_home}/bin/javac
+%javadoc               %{java_home}/bin/javadoc
+
+%add_jvm_extension     JAVA_LIBDIR=%{buildroot}/%{_javadir}    %{_bindir}/jvmjar -l
+
+%jpackage_script() \
+install -d $RPM_BUILD_ROOT%{_bindir}\
+cat > $RPM_BUILD_ROOT%{_bindir}/%5 << 'EOF' \
+#!/bin/sh\
+#\
+# %{name} script\
+# JPackage Project <http://www.jpackage.org/>\
+\
+# Source functions library\
+. %{_javadir}-utils/java-functions\
+\
+# Source system prefs\
+if [ -f %{_sysconfdir}/java/%{name}.conf ]; then\
+    . %{_sysconfdir}/java/%{name}.conf\
+fi\
+\
+# Source user prefs\
+if [ -f $HOME/.%{name}rc ]; then\
+    . $HOME/.%{name}rc\
+fi\
+\
+# Configuration\
+MAIN_CLASS=%1\
+BASE_FLAGS=%2\
+BASE_OPTIONS=%3\
+BASE_JARS="%(echo %4 | tr ':' ' ')"\
+\
+# Set parameters\
+set_jvm\
+set_classpath $BASE_JARS\
+set_flags $BASE_FLAGS\
+set_options $BASE_OPTIONS\
+\
+# Let's start\
+run "$@"\
+EOF
+
+# PEAR install macros
+# Author: Elan Ruusamäe <glen@pld-linux.org>
+#
+# Usage:
+#      %%pear_package_setup [-a #] [-n FMT]
+#
+# -a #   - also unpack SOURCE#. for PEAR bootstrapping
+# -n FMT - create builddir with FMT, instead of default %%{_pearname}-%%{version}
+# -z     - unpack pear package and let pear use package.xml (not tarball) for install. for PEAR bootstrapping
+#
+# unpack PEAR package to %%{_builddir}/FMT. package is extracted with already
+# destination hierarchy. you should copy the tree to buildroot after
+# patching/reorganizing with %%pear_package_install.
+#
+# additionally BUILDROOT is stripped from files and files are converted to UNIX
+# line endings.
+#
+# the pear install process output is recorded to install.log, you should put it
+# to %%doc for later debug or just for information.
+#
+# additionally additional-packages.txt is produced if it was detected that the
+# package has optional dependencies. the file format is suitable of displaying
+# in %%post of a package. you should put this file to %%doc. noautocompressdoc is
+# automatically added for this file.
+
+
+# records install.log and transforms PEAR names to PLD Linux rpm package names.
+%__pear_install_log \
+tee install.log \
+# make post message of optional packages \
+grep 'can optionally use' install.log | sed -e 's,package "pear/,package "php-pear-,g;s,^pear/,php-pear-,' > optional-packages.txt \
+if [ -s optional-packages.txt ]; then \
+       awk -F'"' '/use package/{print $2}' optional-packages.txt | sed -e "s,_,/,g;s,php-pear-, 'pear(,;s,$,.*)'," | tr -d '\\\n' > _noautoreq \
+else \
+       rm -f optional-packages.txt \
+fi \
+%{nil}
+
+# command invoking pear cli
+%__pear /usr/bin/pear
+
+# the main macro.
+# using this macro will append optional-packages.txt to the nocompressdoc list
+# as it's displayed to user after package install. and adding additional gzip
+# dep is just waste ;)
+%pear_package_setup(a:n:z) \
+%define srcdir %{-n*}%{!-n:%{_pearname}-%{version}} \
+%define builddir %{_builddir}/%{srcdir} \
+%setup -q -c -T -n %{srcdir} \
+%{-z:tar zxf %{S:0}; %{-a:tar zxf %{S:%{-a*}}}} \
+%{-z:_P=package2.xml; [ -f $_P ] || _P=package.xml; _N=%{srcdir}; mv $_P $_N; cd $_N} \
+%__pear \\\
+       -c pearrc \\\
+       -d doc_dir=/docs \\\
+       -d php_dir=%{php_pear_dir} \\\
+       -d bin_dir=%{_bindir} \\\
+       -d data_dir=%{php_pear_dir}/data \\\
+       -d test_dir=%{php_pear_dir}/tests \\\
+       install \\\
+       --packagingroot=%{builddir} \\\
+       --offline \\\
+       --nodeps \\\
+       %{-f:--force} \\\
+       %{!-z:%{S:%{-a*}%{!-a:0}}}%{-z:$_P} > .install.log || { c=$?; cat .install.log; exit $c; } \
+%{-z:cd ..} \
+cat %{-z:$_N/}.install.log | %__pear_install_log \
+\
+# undos sources \
+find . -type f -print0 | xargs -0 sed -i -e 's,\\r$,,' \
+%{!?_noautocompressdoc:%global _noautocompressdoc %{nil}}%{expand:%%global _noautocompressdoc %{_noautocompressdoc} optional-packages.txt} \
+%{!?_noautoprov:%global _noautoprov %{nil}}%{expand:%%global _noautoprov %{_noautoprov} 'pear(tests/.*)'} \
+%{nil}
+
+# copies exctracted PEAR package structure to buildroot.
+# also copies PEAR registry file.
+# please use this macro, for future extensions being possible.
+%pear_package_install() \
+cp -a ./%{php_pear_dir}/{.registry,*} $RPM_BUILD_ROOT%{php_pear_dir} \
+find $RPM_BUILD_ROOT%{php_pear_dir} '(' -name '*~' -o -name '*.orig' ')' | xargs -r rm -v \
+# help the developer out a little: \
+if [ -f _noautoreq ]; then \
+       echo "AutoReqdep detected:" \
+       echo "_noautoreq $(cat _noautoreq)" \
+fi \
+%{nil}
+
+
+# Register OpenLDAP schema.
+# Author: Elan Ruusamäe <glen@pld-linux.org>
+#
+# Usage:
+#   %%openldap_schema_register [-d core,nis] %{schemadir}/horde.schema
+#
+#  -d specify dependant schemas, separated by comma
+#
+%openldap_schema_register(d:) \
+for schema in %*; do \
+       if ! grep -q "$schema" /etc/openldap/slapd.conf; then \
+               %{__sed} -i -e " \
+                       /^include.*local.schema/{ \
+                               iinclude\\t     $schema\
+                       } \
+               " /etc/openldap/slapd.conf \
+       fi \
+done \
+# enable dependant schemas \
+if [ "%{-d*}" ]; then \
+       %{__sed} -i -e ' \
+       /^#include.*\\(%(echo '%{-d*}' | %{__sed} -e 's/,/\\\\|/g')\\)\\.schema/{ \
+               s/^#// \
+       }' /etc/openldap/slapd.conf \
+fi \
+%{nil}
+
+# Unregister OpenLDAP schema.
+# Author: Elan Ruusamäe <glen@pld-linux.org>
+#
+# Usage:
+#   %%openldap_schema_unregister %{schemadir}/horde.schema
+#
+%openldap_schema_unregister() \
+for schema in %*; do \
+       if grep -q "$schema" /etc/openldap/slapd.conf; then \
+               %{__sed} -i -e " \
+               /^include.*$(echo "$schema" | %{__sed} -e 's,/,\\\\/,g')/d \
+               # for symmetry it would be nice if we disable enabled schemas in post, \
+               # but we really can not do that, it would break something else. \
+               " /etc/openldap/slapd.conf \
+       fi \
+done \
+%{nil}
+
+%env_update [ ! -x /sbin/env-update ] || /sbin/env-update -u || :
+
+
+# Build modules for kernels 2.6
+# Author: Przemyslaw Iskra <sparky@pld-linux.org>
+#
+# Usage:
+#      %build_kernel_modules -m <modules> -C <directory>
+#
+#  remember that proper Makefile is still required
+# Options:
+#  -m <modules> (required) -- comma-separated list of modules to save,
+#              without .ko extension, may be placed in subdirectory
+#  -C <directory> -- change to <directory> before doing anything
+#  -p <arg>, -P <arg> -- arguments passeed to make scripts
+#  -c -- do not execute make clean
+#  <additional arguments> -- all additional arguments will be passed to
+#              make modules
+#
+# Additional patching supported via here document. Try:
+#      %build_kernel_modules -m module <<'EOF'
+#      your patch script here
+#      EOF
+# Don't use it unless patching depends on config options.
+
+# Developer note: don't touch it unless you know how to handle '\'.
+# - \ in script expands to nothing
+# - \\\ in script expands to \
+# - \\\ inside definition expands to noting
+# - \\\\\\\ inside definition expands to \
+# - in last line \ has to touch arguments so arguments passing
+#   in new lines (using \) will be supported
+
+%build_kernel_modules(p:P:m:C:c)                                                                       \
+%{!?-m:%{error:%{0}: Required module name/list missing} exit 1}                \
+                                                                                                                                       \
+%define Opts                                                                                                           \\\\\\\
+%if "%{_target_base_arch}" != "%{_arch}"                                                       \\\
+       %if "%{_arch}" == "x86_64" && "%{_target_base_arch}" == "i386"  \\\
+       CC="%{__cc}" CPP="%{__cpp}" ARCH=%{_target_base_arch}                   \\\
+       %else                                                                                                                   \\\
+       ARCH=%{_target_base_arch} CROSS_COMPILE=%{_target_cpu}-pld-linux- \\\
+       %endif                                                                                                                  \\\
+%else                                                                                                                          \\\
+       CC="%{__cc}" CPP="%{__cpp}"                                                                             \\\
+%endif                                                                                                                         \
+%define        MakeOpts HOSTCC="%{__cc}" SYSSRC=%{_kernelsrcdir} SYSOUT=$PWD/o \\\\\\\
+               O=$PWD/o %{?with_verbose:V=1} %{Opts}                                           \
+                                                                                                                                       \
+%{?-C:cd %{-C*}}                                                                                                       \
+compile() {                                                                                                                    \
+       L="<"; [[ '%{*}' != *$L$L* ]] || PATCH_SH="set -x -e;$(cat)"    \
+       set -e -x                                                                                                               \
+                                                                                                                                       \
+for cfg in %{?with_dist_kernel:%{?with_smp:smp} up}%{!?with_dist_kernel:nondist}; do \
+       [ -r "%{_kernelsrcdir}/config-$cfg" ] || exit 1                                 \
+                                                                                                                                       \
+       rm -rf o                                                                                                                \
+       install -d o/include/linux                                                                              \
+       ln -sf %{_kernelsrcdir}/config-$cfg o/.config                                   \
+       ln -sf %{_kernelsrcdir}/Module.symvers-$cfg o/Module.symvers    \
+       ln -sf %{_kernelsrcdir}/include/linux/autoconf-$cfg.h o/include/linux/autoconf.h \
+                                                                                                                                       \
+       set +x                                                                                                                  \
+       [ -z "$PATCH_SH" ] || echo "$PATCH_SH" | %__spec_build_shell    \
+       set -x                                                                                                                  \
+                                                                                                                                       \
+       %if %{with dist_kernel}                                                                                 \
+               %{__make} -j1 -C %{_kernelsrcdir} prepare scripts                       \\\
+                       %{-p*} %{-P*}                                                                                   \\\
+                       %{MakeOpts}                                                                                             \
+       %else                                                                                                                   \
+               install -d o/include/config                                                                     \
+               touch o/include/config/MARKER                                                           \
+               ln -sf %{_kernelsrcdir}/scripts o/scripts                                       \
+       %endif                                                                                                                  \
+                                                                                                                                       \
+       %{!?-c:%{__make} -C %{_kernelsrcdir} clean                                              \\\
+               RCS_FIND_IGNORE="-name '*.ko' -o"                                                       \\\
+               M=$PWD %{MakeOpts}}                                                                                     \
+       %{__make} -C %{_kernelsrcdir} modules                                                   \\\
+               ${1+"$@"}                                                                                                       \\\
+               M=$PWD %{MakeOpts}                                                                                      \
+                                                                                                                                       \
+       for MODULE in {%{-m*},}; do                                                                             \
+               [ -z "${MODULE}" ] || mv ${MODULE}{,-$cfg}.ko                           \
+       done                                                                                                                    \
+done                                                                                                                           \
+%{?-C:cd -}                                                                                                                    \
+}                                                                                                                                      \
+compile %{*}\
+%{nil}
+
+
+# Install kernel modules built by %build_kernel_modules
+# Author: Przemyslaw Iskra <sparky@pld-linux.org>
+#
+# Usage:
+#      %install_kernel_modules -m <modules> -d <directory>
+#
+# Options:
+#  -m <modules> (required) -- comma-separated list of modules to install,
+#              without .ko extension, may be placed in subdirectory
+#  -d <directory> (required) -- in what subdirectory modules should be
+#              installed (eg. misc, kernel/drivers/net)
+#  -s <suffix> -- suffix to use when installing modules, useful when module
+#              with same name exists in kernel already
+#  -n <file> -- name of modprobe config file to use (without .conf extension)
+#              for definig aliases, only useful with -s
+
+%install_kernel_modules(m:d:s:n:)                                                                      \
+%{!?-m:%{error:%{0}: Required module name (-m) missing}exit 1}         \
+%{!?-d:%{error:%{0}: Required module directory missing}exit 1}         \
+%{?-n:%{!?-s:%{error:%{0}: Modprobe .conf file requires module suffix}exit 1}} \
+                                                                                                                                       \
+%define KernelD $RPM_BUILD_ROOT/lib/modules/%{_kernel_ver}                     \
+%define ModprobeD $RPM_BUILD_ROOT%{_sysconfdir}/modprobe.d/%{_kernel_ver} \
+                                                                                                                                       \
+install -d %{KernelD}{,smp}/%{-d*}                                                                     \
+%{?-s:install -d %{ModprobeD}{,smp}}                                                           \
+                                                                                                                                       \
+for MODULE in {%{-m*},}; do                                                                                    \
+       [ -n "${MODULE}" ] || continue                                                                  \
+       MNAME=${MODULE##*/}                                                                                             \
+       install ${MODULE}-%{?with_dist_kernel:up}%{!?with_dist_kernel:nondist}.ko \\\
+               %{KernelD}/%{-d*}/${MNAME}%{-s:-%{-s*}}.ko                                      \
+       %{?-s:echo "alias ${MNAME} ${MNAME}-%{-s*}"                                             \\\
+               >> %{ModprobeD}/%{-n*}.conf}                                                            \
+    %if %{with smp} && %{with dist_kernel}                                                     \
+       install ${MODULE}-smp.ko                                                                                \\\
+               %{KernelD}smp/%{-d*}/${MNAME}%{-s:-%{-s*}}.ko                           \
+       %{?-s:echo "alias ${MNAME} ${MNAME}-%{-s*}"                                             \\\
+               >> %{ModprobeD}smp/%{-n*}.conf}                                                         \
+    %endif                                                                                                                     \
+done                                                                                                                           \
+%{nil}
+
+# vim:ts=4 sw=4 noet syn=spec
This page took 0.792993 seconds and 4 git commands to generate.